# Mage2 Module FiloBlu OrderFlowRectifier

    ``filoblu/module-orderflowrectifier``

 - [Main Functionalities](#markdown-header-main-functionalities)
 - [Configuration](#markdown-header-configuration)
 - [Specifications](#markdown-header-specifications)


## Main Functionalities

Fixes stuck orders by fixing status, payment information or other order data.

A rectifier has been developed for each pf the following use case:

 - Ordine adyen fermo in order exported, mancano i dati del pagamento (MissingPaymentInfoRectifier)
 
 - Ordine adyen fermo in order exported. Lo state dell’ordine è rimasto in payment_review, oppure lo status semplicemente non è aggiornato. (PaymentReviewRectifier)
 
 - Ordine adyen fermo in order exported. Lo status è corretto, ma lo state è rimasto payment_review invece di passare a processing (PaymentReviewStateRectifier)
 
 - Invoice creata ma ordine non modificato nei campi “invoiced”, "paid" e "due". (InvoicedRectifier)
 
 - Ordine rimasto shipped, mentre dovrebbe essere complete. Tutti gli item sono invoiced e shipped. (ShippedRectifier)
 
 - Gestione mail di conferma per gli ordini effettuati negli ultimi 2 giorni con i metodi di pagamento definiti, con lo status fino a 'send_to_logistic' e nei quali la mail non è ancora stata inviata. (SendEmailOrderConfirmationRectifier)
 
 - Status ordine non allineato alla history aggiornata a order_exported. Allineamento status a order_exported. (OrderExportedStatusUpdateRectifier)
 
 - Ordine rimasto in processing mentre la history è aggiornata a confirmed e il metodo di pagamento è PayPal. Allineamento status a confirmed. (ConfirmedStatusUpdateRectifier)
 
 - Inserimento dati in ESB per sistemare gli ordini che hanno avuto problemi con i cambi di stato. (EsbScheduleUpdateRectifier)
   
 - Ordini bloccati in order exported che non riescono a cambiare stato in quanto mancano infomrazioni realative alla transazione; recupero e aggiornamento di tali info. (OrderPaymentDataIncompleteRectifier)
 
 Rectifiers should be scheduled and ran regularly.
 
 
 The "Enable fix for missing cc_type" option, if activated, checks the orders placed by credit card and if cc_type is missing retrieves it from adyen_notification and saves it in sales_order_payment. 


## Configuration

 - Enable Scheduled Operations (order_flow_rectifier/general/scheduled_ops_enabled) 

 - Enabled rectifiers (order_flow_rectifier/general/enabled_rectifiers)
 
 - Enable fix for missing cc_type (order_flow_rectifier/general/scheduled_cctype_check_enabled)


## Specifications

 - Cronjob
	- filoblu_orderflowrectifier_rectifier
